##############################################################################
#
# This is R code for drawing cost plots using several distribution for costs
#   and several other features for evaluating classifiers.
## It draws:
#	- the ROC curve and convex hull* (function roc)
# 	- the rate driven curve, kendall curve and convex skull (rcc4 function)
# 	- the AUC measure (auc measure)
#     
## TO DO:
#          - Deal with Ties
#          - Review Convex Skull of Kendall curves
#          - Review Skew version 
# This code has been developed by
#   Cesar Ferri, UNIVERSITAT POLITECNICA DE VALENCIA, SPAIN
#   cferri@dsic.upv.es
# 
# and using ideas from:
#   JOSE HERNANDEZ-ORALLO, UNIVERSITAT POLITECNICA DE VALENCIA
#   PETER FLACH, UNIVERSITY OF BRISTOL
# 
##############################################################################

VERTICAL_LINES<-TRUE
LINESCOST<-TRUE	
SPLITPOINTS<-TRUE
CORRECTEDCURVE<-TRUE
SKEW<-FALSE
RATEDRIVENCURVE<-TRUE
CONVEXSKULL<-TRUE #a mà
COLOURCORRECTED<-"blue"
COLOURCURVE<-"brown"
#COLOURCURVE<-"brown"
BALANCELINE<-TRUE
ORDERDECREASING<-TRUE
POSITIVE1<-FALSE

###########ROC#############
#computeConvexull
convexhull<-function(pointsx,pointsy)

  {
    rpx<-c(pointsx,1)
      rpy<-c(pointsy,0)
                                        #print(rpx)
                                        #print(rpy)
      z<-sort(chull(rpx,rpy))
 #     print(z[1:length(z)-1])
     punts<-z[1:length(z)-1]
      
  #   print(-(punts-(n+2)))
     convexhull<-punts
}
############ROC#############
#########R################## #sense empats
roc <- function(inp,pplot,newplot)
{

  if (POSITIVE1) inp<-1-inp
  inp<-inp[order(inp[,2],decreasing=ORDERDECREASING), ]
                                        #print(inp)
  
  n<-length(inp[,1])
  np<-sum(inp[,1])
  nn<-n-np
                       
  
    if (pplot && newplot==TRUE) plot(c(0,1),c(0,0), ylim=c(0,1),xlab= "F1",ylab= "F0", col="white")

                                        #Busquem empats:
  i<-1
  e<-c(1:3)
  e[1]<-1
  
  for (i in 2:n)
    {
      
      if (inp[i-1,2]!=inp[i,2]) 
        {
          e[i]<-1
          i<-i+1		
        }
      else
        { #print(i)
          e[i]<-0
          i<-i+1
	}
                                        #	print(i)
    }
#  print(e)
  
  n<-length(inp[,1])
  nn<-sum(inp[,1])
  np<-n-np
  Area<-0
  print("examples")
  print(n)
  print("pos")
  print(np)
  print("neg")
  print(nn)
                                        #stepy<-2/n cost
  stepyp<-1/np
  stepyn<-1/nn
                                        #step<-1/(trunc(n/2)+1)
                                        #print(step)
  
#### BUCLE PRINCIPAL
  
  c<-1
  xo<-0
  yo<-0
  xn<-0
  yn<-0
  ap<-1
  an<-1
  
  nnp<-0
  npp<-0
  area<-0
  pointsx<-c()
  pointsy<-c()
  
  i<-1
  pix<-0
  piy<-0
  pfx<-0
  pfy<-0
                                        #diagonals
  while(i<(n+1))
    {
                                        #  xa<-0
                                        # ya<-0
                                        # if (lnly>1) xa<-lnly-1
                                        # if (lndx>1) ya<-lndx-1
      if (i>np) pix<-pix+stepyn
      else  piy<-piy+stepyp
                                        # print("punts i")
                                        # print(pix)
                                        # print(piy)
      if (i<=nn) pfx<-pfx+stepyn
      else pfy<-pfy+stepyp
                                        # print("punts f")
                                        #print(pfx)
                                        #print(pfy)
      if (pplot) lines(c(pix,pfx),c(piy,pfy), lty=1, col= "grey")
      if (BALANCELINE && i==np)	if (pplot  ) 	lines( c(pix,pfx),c(piy,pfy),lty=1, col= "black")
      
      i<-i+1
    }
  
  i<-1 
  
  while(i<(n+1))
    {
                                        #positiu
      if(inp[i,1]==0)
        { yn<-yo+stepyp*ap
          npp<-npp+1}
      else 
        {#negatiu
          xn<-xo+stepyn*an
          nnp<-nnp+1
        }
      
      if (e[i]==1)
        {
          
          
          if(inp[i,1]==0) yn<-yo+stepyp*ap
          else xn<-xo+stepyn*an
          if (pplot && SPLITPOINTS) points(c(xo,xn),c(yo,yn),col="blue4") 
          if (pplot) 	lines(c(xo,xn),c(yo,yn), lty=1, col= COLOURCURVE)	
          pointsx[i]<-xo
          pointsy[i]<-yo
          pointsx[i+1]<-xn
          pointsy[i+1]<-yn
          yo<-yn
          xo<-xn
          
          
        }
      else
        {
          if(inp[i,1]==0) ap<-ap+1
          else an<-an+1
        }
      i<-i+1
      
    }
  
  
  if (CONVEXSKULL)
    {
      
  
      punts<-convexhull(pointsx,pointsy)
      
      nump<-length(punts)	
      
      for(i in (nump-1):1)
	{
          if (pplot  )  lines(c(pointsx[punts[i]],pointsx[punts[i+1]]),c(pointsy[punts[i]],pointsy[punts[i+1]]),col=COLOURCURVE,lty=2,lwd=2)
	}
    }
  roc<-list(pointsx,pointsy)
}

############AUC#############
auc <- function (inp)
{
  
  
  n<-length(inp[,1])
  np<-sum(inp[,1])
  nn<-n-np
  
  c<-0
  for (i in 1:n)
    if(inp[i,1]==1)
      {
        for (j in 1:n)
          {
            if(inp[j,1]==0 && inp[i,2]>inp[j,2]) c<-c+1
            if(inp[j,1]==0 && inp[i,2]==inp[j,2]) c<-c+0.5
          }
      }
  
  auc<-c/(np*nn)
}


#############################################################
#########RCC##################
rcc4 <- function(inp,pplot,newplot,mcol)
{
  if (POSITIVE1) inp<-1-inp
  inp<-inp[order(inp[,2],decreasing=!ORDERDECREASING), ]
  
                                        #Ordenem
  
  if (SKEW)
    {
      if (pplot && newplot==TRUE) plot(c(0,1),c(0,0), ylim=c(0,1), main= "",xlab= "skew",ylab= "loss", col="white")
    }
  else if (pplot && newplot==TRUE) plot(c(0,1),c(0,0), ylim=c(0,1), main= "",xlab= "cost",ylab= "loss", col="white")
  n<-length(inp[,1])
  np<-sum(inp[,1])
  nn<-n-np
                                        #print(np/nn)
  Area<-0
  Areap<-0
  
  if (SKEW)
    {
      stepyp<-1/np
      stepyn<-1/nn
    }
  else
    {
      stepyp<-2/n #cost
      stepyn<-2/n #cost
    }
  stepx<-1/n
  bal<-np/n
  
                                        #Busquem empats:
  i<-1
  e<-c(1:3)
  e[1]<-1
  
  for (i in 2:n)
    {
      
      if (inp[i-1,2]!=inp[i,2]) 
        {
          e[i]<-1
          i<-i+1		
        }
      else
        { #print(i)
          e[i]<-0
          i<-i+1
	}
                                        #	print(i)
    }
                                        #print(e)
  
  
  ptsl<-c()
  ptsr<-c()
  steps<-c()
  lx<-c()
  ly<-c()
  lp<-c()
  ns<-0
  #linies de cost
  ##Primer Tram
  yl<-stepyp*np
                                        #print(yl)T
  yr<-0
  x<-1
  if (pplot && newplot==TRUE &&LINESCOST) 	lines(c(0,1),c(yl,yr), lty=2, lwd=1.5 ,col= "grey")
                                        #e<-c(1:n)
  ptsl[1]<-yl#1 en skews
  ptsr[1]<-yr
  
  
  steps[1]<-stepx
  ns<-1
#### BUCLE PRINCIPAL
  i<-2 #linies de cost 
  c<-1
  while(i<(n+1))
    {
                                        #print("stepy")
                                        #print(stepyp)
                                        #print(yr)
      if(inp[i-1,1]==0) yr<-yr+stepyn
      else yl<-yl-stepyp
      if (e[i]==1)# sols si no es un empat
        {
          if (pplot && newplot==TRUE && LINESCOST) 	lines(c(0,1),c(yl,yr), lty=2, lwd=1.5, col= "grey")
          ns<-ns+1
          ptsl[ns]<-yl
          ptsr[ns]<-yr
          steps[ns-1]<-stepx*c
          c<-0
        }
      i<-i+1
      c<-c+1
    }
  
  steps[ns]<-stepx*c
  
  ##Ultim Tram
  
  if (SKEW) 
    {
      if (pplot && newplot==TRUE && LINESCOST ) 	lines(c(0,1),c(0,1), lty=2, lwd=1.5, col= "grey")
      ptsl[ns+1]<-0
      ptsr[ns+1]<-1
      lp[1]<--1
    }
  else 
    {
      if (pplot && newplot==TRUE && LINESCOST ) 	lines(c(0,1),c(0,stepyn*nn), lty=2, lwd=1.5, col= "grey")
      ptsl[ns+1]<-0
      ptsr[ns+1]<-stepyn*nn
      lp[1]<--stepyn*nn
    }
                                        #steps[1]<-stepx
                                        #print(ns)	
  
                                        #print(ptsl)
                                        #print(ptsr)
                                        #print(steps)
                                        #  POINTS (split points)
#Linies Verticals
  j<-1
  for (i in 0:ns) {
    if (pplot && newplot==TRUE && VERTICAL_LINES) lines(c(j,j),c(0,1), lty=1, col= "grey")
       #Remarquem la del balance
    if (BALANCELINE && i==np) if (pplot && newplot==TRUE && VERTICAL_LINES) lines(c(j,j),c(0,1), lty=1, col= "black")
    j<-j-steps[i+1]
  }
  #Splitpoints
  if (pplot && SPLITPOINTS) points(0,0,col="red") 
                                        #print("d")
                                        #print(0)
  i<-ns
  xf<-0
  while(i>0)
    {
      
      x1<-xf
      x2<-xf+steps[i]
      p2<-ptsr[i]-ptsl[i]
      p1<-ptsr[i+1]-ptsl[i+1]
                                        
      y1<-ptsl[i+1]+p1*x1
      y2<-ptsl[i]+p2*x1
      if (pplot && SPLITPOINTS) points(x2,ptsl[i]+p2*x2,col="red") 
           
    if (RATEDRIVENCURVE && pplot)  curve(((p2-p1)*x^2+(p1*x1-2*p2*x1+p1*x2-y1+y2)*x+(p2*x1^2-p1*x1*x2+x2*y1-x1*y2))/(x2-x1),x1,x2,lwd=3, lty=1,add=TRUE,col=mcol)  
      
      if (CORRECTEDCURVE) 
        if (SKEW)
          {
            if (i>(bal*n)) 
              {	
                if (pplot) curve((((p2-p1)*x^2+(p1*x1-2*p2*x1+p1*x2-y1+y2)*x+(p2*x1^2-p1*x1*x2+x2*y1-x1*y2))/(x2-x1))-(x-(x)^2/(1-bal)),x1,x2,lwd=2,lty=1,add=TRUE,col=COLOURCORRECTED)  
                if (pplot && SPLITPOINTS) points(x2,(((p2-p1)*x2^2+(p1*x1-2*p2*x1+p1*x2-y1+y2)*x2+(p2*x1^2-p1*x1*x2+x2*y1-x1*y2))/(x2-x1))-(x2-(x2)^2/(1-bal)),col=COLOURCORRECTED) 
                
              }
            else 
              {
		if (pplot)	curve((((p2-p1)*x^2+(p1*x1-2*p2*x1+p1*x2-y1+y2)*x+(p2*x1^2-p1*x1*x2+x2*y1-x1*y2))/(x2-x1))-((x-(1-bal))-((x-(1-bal))^2/bal)),x1,x2,lwd=2,lty=1,add=TRUE,col=COLOURCORRECTED)  
		if (pplot && SPLITPOINTS) points(x2,(((p2-p1)*x2^2+(p1*x1-2*p2*x1+p1*x2-y1+y2)*x2+(p2*x1^2-p1*x1*x2+x2*y1-x1*y2))/(x2-x1))-((x2-(1-bal))-((x2-(1-bal))^2/bal)),col=COLOURCORRECTED) 
                
              }
          }
        else	{
          if (i>(bal*n)) 
            {
           	if (pplot)   curve((((p2-p1)*x^2+(p1*x1-2*p2*x1+p1*x2-y1+y2)*x+(p2*x1^2-p1*x1*x2+x2*y1-x1*y2))/(x2-x1))-(2 * (nn/n)*x*(1-x/(nn/n))),x1,x2,lwd=2,lty=1,add=TRUE,col=COLOURCORRECTED)  
              if (pplot && SPLITPOINTS) points(x2,(((p2-p1)*x2^2+(p1*x1-2*p2*x1+p1*x2-y1+y2)*x2+(p2*x1^2-p1*x1*x2+x2*y1-x1*y2))/(x2-x1))-(2 * (nn/n)*x2*(1-x2/(nn/n))),col=COLOURCORRECTED) 
              
            }
          else 
            {
             	if (pplot) curve((((p2-p1)*x^2+(p1*x1-2*p2*x1+p1*x2-y1+y2)*x+(p2*x1^2-p1*x1*x2+x2*y1-x1*y2))/(x2-x1))-(2 * (np/n)*(x-(1-bal))*(1-(x-(1-bal))/(np/n))),x1,x2,lwd=2,lty=1,add=TRUE,col=COLOURCORRECTED)  
              if (pplot && SPLITPOINTS) points(x2,(((p2-p1)*x2^2+(p1*x1-2*p2*x1+p1*x2-y1+y2)*x2+(p2*x1^2-p1*x1*x2+x2*y1-x1*y2))/(x2-x1))-(2 * (np/n)*(x2-(1-bal))*(1-(x2-(1-bal))/(np/n))),col=COLOURCORRECTED) 
            }
	}
      
      An<-((p2-p1)*(x2^3-x1^3)/3+(p1*x1-2*p2*x1+p1*x2-y1+y2)*(x2^2-x1^2)/2+(p2*x1^2-p1*x1*x2+x2*y1-x1*y2)*(x2-x1))/(x2-x1)
      Ap<-0
      
      
     # correction<-0
     # if (SKEW)
     #   {
     #     if (x2<=(1-bal)) correction<-(x2^2/2-x2^3/(3*(1-bal)))-(x1^2/2-x1^3/(3*(1-bal)))
     #     else  correction<-((x2-nn/n)^2/2-1/(3*(1-nn/n))*(x2-nn/n)^3)-((x1-nn/n)^2/2-1/(3*(1-nn/n))*(x1-nn/n)^3)
     #   }
     # else
     #   {
     #     if (x2<=(1-bal)) correction<-( (nn/n)*x2^2 -2/3*(x2^3)  - ((nn/n)*x1^2 -2/3*(x1^3)))
     #     else  correction<-((np/n)*(x2-nn/n)^2-2/3*(x2-nn/n)^3)- ((np/n)*(x1-nn/n)^2-2/3*(x1-nn/n)^3)
     #         }
      lx[i+1]<-x1
      ly[i+1]<-y1
      lp[i+1]<-p1
      
      Area<-Area+An
      
      
      i<-i-1
      xf<-x2
    }
  
  lx[1]<-1
  ly[1]<-0
        
  if (CONVEXSKULL)
    {
  
#    punts<-c(1,3,5,9,11) #exemple A
#       punts<-c(1,8,11) #exemple B
      #we compute the points of the convex hull by computing the points of the ROC curve and the convex hull
      lpunts<-roc(imp,FALSE,FALSE)
#       lpunts<-c(1,3,6,7) #exemple B
      punts<-convexhull(lpunts[[1]],lpunts[[2]])
#       print("punts")
 #     print(punts)
      #points are in reverse order
      punts<-sort(-(punts-(n+2)))
#      print("punts")
 #     print(punts)
      nump<-length(punts)	
      
      for(i in nump:1)
	{
          l<-punts[i]
          if (i<nump)	r<-punts[i+1]
          else r<-n+1
          x1<-lx[l]
          x2<-lx[r]
          y1<-ly[l]
                                        #y2<-ly[r]
          p1<-lp[l]
          p2<-lp[r]
                                        #y1<-ptsl[i+1]+p1*x1
          y2<-ptsl[r]+p1*x2
                                        #lines(c(x1,x2),c(y1,y2), col="blue")
                                        #	curve(ptsl[i]+x*(ptsr[i]-ptsl[i]),x1,x2,col="blue",add=TRUE)
                                        #	curve(ptsl[i+1]+x*(ptsr[i+1]-ptsl[i+1]),x1,x2,col="brown",add=TRUE)
          curve((x2-x)/(x2-x1)*(ptsl[l]+x*(ptsr[l]-ptsl[l]))+(x-x1)/(x2-x1)*(ptsl[r]+x*(ptsr[r]-ptsl[r])),x1,x2,col=COLOURCURVE,lty=2,lwd=1,add=TRUE)
                                        #(x2-x)
### No està correcte del tot, partim un troç per el mig
          if (CORRECTEDCURVE) 
            if (SKEW)
              {
                if (l>(bal*n)) curve((x2-x)/(x2-x1)*(ptsl[l]+x*(ptsr[l]-ptsl[l]))+(x-x1)/(x2-x1)*(ptsl[r]+x*(ptsr[r]-ptsl[r]))-(x-(x)^2/(1-bal)),x1,x2,lwd=1,lty=2,add=TRUE,col=COLOURCORRECTED)  
                else
                  if(l<(bal*n)) curve((x2-x)/(x2-x1)*(ptsl[l]+x*(ptsr[l]-ptsl[l]))+(x-x1)/(x2-x1)*(ptsl[r]+x*(ptsr[r]-ptsl[r]))-((x-(1-bal))-((x-(1-bal))^2/bal)),x1,x2,lwd=1,lty=2,add=TRUE,col=COLOURCORRECTED)  
                  else
                    {
                      curve((x2-x)/(x2-x1)*(ptsl[l]+x*(ptsr[l]-ptsl[l]))+(x-x1)/(x2-x1)*(ptsl[r]+x*(ptsr[r]-ptsl[r]))-(x-(x)^2/(1-bal)),x1+(x2-x1)/2,x2,lwd=1,lty=2,add=TRUE,col=COLOURCORRECTED)  
                      curve((x2-x)/(x2-x1)*(ptsl[l]+x*(ptsr[l]-ptsl[l]))+(x-x1)/(x2-x1)*(ptsl[r]+x*(ptsr[r]-ptsl[r]))-((x-(1-bal))-((x-(1-bal))^2/bal)),x1,x2-(x2-x1)/2,lwd=1,lty=2,add=TRUE,col=COLOURCORRECTED)  
                    }
              }
            else
              {
                if (l>(bal*n)) curve((x2-x)/(x2-x1)*(ptsl[l]+x*(ptsr[l]-ptsl[l]))+(x-x1)/(x2-x1)*(ptsl[r]+x*(ptsr[r]-ptsl[r]))-(2 * (nn/n)*x*(1-x/(nn/n))),x1,x2,lwd=1,lty=2,add=TRUE,col=COLOURCORRECTED)  
                else
                  if(l<(bal*n)) curve((x2-x)/(x2-x1)*(ptsl[l]+x*(ptsr[l]-ptsl[l]))+(x-x1)/(x2-x1)*(ptsl[r]+x*(ptsr[r]-ptsl[r]))-(2 * (np/n)*(x-(1-bal))*(1-(x-(1-bal))/(np/n))),x1,x2,lwd=1,lty=2,add=TRUE,col=COLOURCORRECTED)  
                  else 
                    {
                      curve((x2-x)/(x2-x1)*(ptsl[l]+x*(ptsr[l]-ptsl[l]))+(x-x1)/(x2-x1)*(ptsl[r]+x*(ptsr[r]-ptsl[r]))-(2 * (np/n)*(x-(1-bal))*(1-(x-(1-bal))/(np/n))),x1,x2-(x2-x1)/2,lwd=1,lty=2,add=TRUE,col=COLOURCORRECTED)  
                      curve((x2-x)/(x2-x1)*(ptsl[l]+x*(ptsr[l]-ptsl[l]))+(x-x1)/(x2-x1)*(ptsl[r]+x*(ptsr[r]-ptsl[r]))-(2 * (nn/n)*x*(1-x/(nn/n))),x1+(x2-x1)/2,x2,lwd=1,lty=2,add=TRUE,col=COLOURCORRECTED)
                    }
              }
  	}
    }
  
                                        #Lower envelope del exemple B
#  lines(c(0.43,1),c((1-0.43)*0.6,0),lty=2,lwd=1, col= "black")
#  lines(c(0,0.43),c(0,(1-0.43)*0.6),lty=2,lwd=1, col= "black")
 #Lower envelope del exemple A
 #   lines(c(0,0.25),c(0,0.25),lty=2,lwd=1, col= "black")
#lines(c(0.25,0.5),c(0.25,0.25+0.2*0.25),lty=2,lwd=1, col= "black")
  #lines(c(0.5,1),c(0.25+0.2*0.25,0),lty=2,lwd=1, col= "black")
#punt exemple
#points(0.4,0.2*0.4+0.2,pch=19 ,col="red",lwd=2) 

                                        
  
  rcc4<-Area
}


#Classifiers for examples
#we use two arrays, the first for classes (by default 0 is positive), and the second for scores 


                                        #inpmagic <- cbind(c(1,1,0,1,1,1,0,1,0,1),c(0.95,0.9,0.8,0.7,0.65,0.6,0.5,0.4,0.3,0.2))#example paper for RCC
                                        #inpmagic <- cbind(c(0,0,0,0,0,0,0,1,1,1),c(0.95,0.9,0.8,0.7,0.65,0.6,0.5,0.4,0.3,0.2))#example paper best
                                        inpmagic <- cbind(c(0,0,1,0,0,0,1,0,1,0),c(0.95,0.9,0.8,0.7,0.65,0.6,0.5,0.4,0.3,0.2)) #example paper 1

#inpmagic <- cbind(c(0,0,0,1,0,1,1,0,0,0),c(0.95,0.9,0.8,0.7,0.65,0.6,0.5,0.4,0.3,0.2)) #example paper 2

                                        #inpmagic <- cbind(c(1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0),c(0.95, 0.93, 0.92, 0.91, 0.90, 0.73, 0.70, 0.55,0.45, 0.21, 0.20, 0.18, 0.16, 0.15, 0.05))
                                        #inpmagic <- cbind(c(1,0,1,0,0),c(0.9,0.8,0.7,0.6,0.5))
                                        #inpmagic <- cbind(c(1,0,0,1),c(0.7,0.6,0.5,0.2))
                                        #inpmagic <- cbind(c(1,1,1,1,1,1,1,0,0,0),c(0.9,0.8,0.7,0.6,0.5,0.4,0.3,0.2,0.1,0.05))
                                        #inpmagic <- cbind(c(0,1,0,0,1,1),c(0.8,0.7,0.6,0.5,0.3,0.2))
                                        #inpmagic <- cbind(c(0,1,0,1),c(0.8,0.6,0.5,0.4))



imp<-inpmagic
#pdf("example2-roc-curve.pdf")
a<-rcc4(imp,TRUE,TRUE,COLOURCURVE)
#a<-roc(imp,TRUE,TRUE)

#dev.off()
#


